

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
//#include <avr/sleep.h>
#include <stdio.h>


int RL_tryout(char c)
{
	if (c == '\n') {
		// first output a carriage return
		RL_tryout('\r');
	}
	loop_until_bit_is_set(UCSR1A, UDRE);
	UDR1 = c;
	
	return 0;
}

void RL_USART_Init(uint16_t ubrr)
{
	UBRR1H = ubrr >> 8;
	UBRR1L = ubrr & 0xff;
	UCSR1B = _BV(TXEN);
	stdout = fdevopen(RL_tryout, NULL, 0);
	stderr = stdout;
}


void RL_USART_Putc1(char c) {
  RL_tryout(c);
}


int main(void) {
	RL_USART_Init(51);
	
	fprintf(stdout, "fprintf\n");
	fprintf_P(stdout, PSTR("fprintf_P\n"));
	fputs("fputs\n", stdout);
	fputs_P(PSTR("fputs_P\n"), stdout);
	fputc('X', stdout);
	RL_USART_Putc1('Y');
	RL_USART_Putc1('\n');

	return 0;
}


